;; 
; Tests only the following multi parser features:
; '()
; '(id)
; '(id xlink)

;------------------------------------------------
; Just an ordinary SSAX parser

; (SSAX:multi-parser)
(xtest-assert ; Expected result:
'(*TOP*
 (*PI* xml "version='1.0'")
 (doc
  (replace
    (@ (http://www.w3.org/1999/xlink:type "extended") (id "replace"))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "target")
      (http://www.w3.org/1999/xlink:role "booboo")
      (http://www.w3.org/1999/xlink:label "boo")
      (http://www.w3.org/1999/xlink:href "#replace")))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "ending resource1")
      (http://www.w3.org/1999/xlink:role "text/xml")
      (http://www.w3.org/1999/xlink:label "hoge")
      (http://www.w3.org/1999/xlink:href "target.xml")))
    (arc
     (@
      (http://www.w3.org/1999/xlink:type "arc")
      (http://www.w3.org/1999/xlink:to "hoge")
      (http://www.w3.org/1999/xlink:title "replace traversal example")
      (http://www.w3.org/1999/xlink:show "replace")
      (http://www.w3.org/1999/xlink:from "boo")
      (http://www.w3.org/1999/xlink:actuate "onRequest"))))
  (new
   (@ (http://www.w3.org/1999/xlink:type "extended") (id "new"))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "target")
     (http://www.w3.org/1999/xlink:role "booboo")
     (http://www.w3.org/1999/xlink:label "boo")
     (http://www.w3.org/1999/xlink:href "#new")))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "ending resource2")
     (http://www.w3.org/1999/xlink:role "text/xml")
     (http://www.w3.org/1999/xlink:label "hoge")
     (http://www.w3.org/1999/xlink:href "target.xml")))
   (arc
    (@
     (http://www.w3.org/1999/xlink:type "arc")
     (http://www.w3.org/1999/xlink:to "hoge")
     (http://www.w3.org/1999/xlink:title "new traversal example")
     (http://www.w3.org/1999/xlink:show "new")
     (http://www.w3.org/1999/xlink:from "boo")
     (http://www.w3.org/1999/xlink:actuate "onRequest"))))
  (embed
   (@ (http://www.w3.org/1999/xlink:type "extended") (id "embed"))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "target")
     (http://www.w3.org/1999/xlink:role "booboo")
     (http://www.w3.org/1999/xlink:label "boo")
     (http://www.w3.org/1999/xlink:href "#embed")))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "ending resource3")
     (http://www.w3.org/1999/xlink:role "text/xml")
     (http://www.w3.org/1999/xlink:label "hoge")
     (http://www.w3.org/1999/xlink:href "target.xml")))
   (arc
    (@
     (http://www.w3.org/1999/xlink:type "arc")
     (http://www.w3.org/1999/xlink:to "hoge")
     (http://www.w3.org/1999/xlink:title "embed traversal example")
     (http://www.w3.org/1999/xlink:show "embed")
     (http://www.w3.org/1999/xlink:from "boo")
     (http://www.w3.org/1999/xlink:actuate "onRequest"))))))
; <--- of:
(SSAX:multi-parser)
(open-input-resource "test1.xml")
)

; (SSAX:multi-parser)
(xtest-assert ; Expected result:
'(*TOP*
 (*PI* xml "version='1.0' encoding=\"Shift_JIS\"")
 (doc
  (multidirectional
    (@ (http://www.w3.org/1999/xlink:type "extended"))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "Chap.1 toc")
      (http://www.w3.org/1999/xlink:role "booboo")
      (http://www.w3.org/1999/xlink:label "boo")
      (http://www.w3.org/1999/xlink:href "#toc1")))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "Chap.1 cont")
      (http://www.w3.org/1999/xlink:role "text/xml")
      (http://www.w3.org/1999/xlink:label "hoge")
      (http://www.w3.org/1999/xlink:href "#chap1")))
    (arc
     (@
      (http://www.w3.org/1999/xlink:type "arc")
      (http://www.w3.org/1999/xlink:to "hoge")
      (http://www.w3.org/1999/xlink:title "Traversal to content page")
      (http://www.w3.org/1999/xlink:show "replace")
      (http://www.w3.org/1999/xlink:from "boo")
      (http://www.w3.org/1999/xlink:actuate "onRequest")))
    (arc
     (@
      (http://www.w3.org/1999/xlink:type "arc")
      (http://www.w3.org/1999/xlink:to "boo")
      (http://www.w3.org/1999/xlink:title "Traversal to toc page")
      (http://www.w3.org/1999/xlink:show "replace")
      (http://www.w3.org/1999/xlink:from "hoge")
      (http://www.w3.org/1999/xlink:actuate "onRequest"))))
  (item (@ (id "toc1")) "chapter1")
  (item (@ (id "toc2")) "chapter2")
  (item (@ (id "toc3")) "chapter3")
  (item (@ (id "toc4")) "chapter4")
  (item (@ (id "toc5")) "chapter5")
  (item (@ (id "toc6")) "chapter6")
  (item (@ (id "toc7")) "chapter7")
  (body
   (chapter
     (@ (id "chap1"))
     (title "Abstract")
     (p "This document describes about XLink Engine..."))
   (chapter
     (@ (id "chap2"))
     (title "Introduction")
     (section
       (@ (ID "sec2-1"))
       (p
        "This document is written in XML (eXtensible Markup Language) ver.1.0.")))
   (chapter (@ (id "chap3")) (title "What is XLink?") (p "hyperlink"))
   (chapter
     (@ (id "chap4"))
     (title "What is XPointer?")
     (p
      "XPointer is the fragment identifier of documents having the mime-type hogehoge."))
   (chapter
     (@ (id "chap5"))
     (title "Models for using XLink/XPointer ")
     (p "There are important keywords."))
   (chapter (@ (id "chap6")) (title "samples"))
   (chapter (@ (id "chap7")) (title "Conclusion") (p "Thanks a lot."))
   (appendix
     (@ (id "here"))
     (bibliographic
       (item
        (author "Who1")
        (title "XML Linking Language (XLink)")
        (ref "foo.com"))
       (item
        (author "Who2")
        (title "XML Pointing Language (XPointer)")
        (ref "boo.com")))))))
; <--- of:
(SSAX:multi-parser)
(open-input-resource "test2.xml")
)


;------------------------------------------------
; Parser with id index creation

; (SSAX:multi-parser (quote id))
(xtest-assert ; Expected result:
'(*TOP*
 (@@
  (id-index
    ("embed"
     embed
     (@ (http://www.w3.org/1999/xlink:type "extended") (id "embed"))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "target")
       (http://www.w3.org/1999/xlink:role "booboo")
       (http://www.w3.org/1999/xlink:label "boo")
       (http://www.w3.org/1999/xlink:href "#embed")))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "ending resource3")
       (http://www.w3.org/1999/xlink:role "text/xml")
       (http://www.w3.org/1999/xlink:label "hoge")
       (http://www.w3.org/1999/xlink:href "target.xml")))
     (arc
      (@
       (http://www.w3.org/1999/xlink:type "arc")
       (http://www.w3.org/1999/xlink:to "hoge")
       (http://www.w3.org/1999/xlink:title "embed traversal example")
       (http://www.w3.org/1999/xlink:show "embed")
       (http://www.w3.org/1999/xlink:from "boo")
       (http://www.w3.org/1999/xlink:actuate "onRequest"))))
    ("new"
     new
     (@ (http://www.w3.org/1999/xlink:type "extended") (id "new"))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "target")
       (http://www.w3.org/1999/xlink:role "booboo")
       (http://www.w3.org/1999/xlink:label "boo")
       (http://www.w3.org/1999/xlink:href "#new")))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "ending resource2")
       (http://www.w3.org/1999/xlink:role "text/xml")
       (http://www.w3.org/1999/xlink:label "hoge")
       (http://www.w3.org/1999/xlink:href "target.xml")))
     (arc
      (@
       (http://www.w3.org/1999/xlink:type "arc")
       (http://www.w3.org/1999/xlink:to "hoge")
       (http://www.w3.org/1999/xlink:title "new traversal example")
       (http://www.w3.org/1999/xlink:show "new")
       (http://www.w3.org/1999/xlink:from "boo")
       (http://www.w3.org/1999/xlink:actuate "onRequest"))))
    ("replace"
     replace
     (@ (http://www.w3.org/1999/xlink:type "extended") (id "replace"))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "target")
       (http://www.w3.org/1999/xlink:role "booboo")
       (http://www.w3.org/1999/xlink:label "boo")
       (http://www.w3.org/1999/xlink:href "#replace")))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "ending resource1")
       (http://www.w3.org/1999/xlink:role "text/xml")
       (http://www.w3.org/1999/xlink:label "hoge")
       (http://www.w3.org/1999/xlink:href "target.xml")))
     (arc
      (@
       (http://www.w3.org/1999/xlink:type "arc")
       (http://www.w3.org/1999/xlink:to "hoge")
       (http://www.w3.org/1999/xlink:title "replace traversal example")
       (http://www.w3.org/1999/xlink:show "replace")
       (http://www.w3.org/1999/xlink:from "boo")
       (http://www.w3.org/1999/xlink:actuate "onRequest"))))))
 (*PI* xml "version='1.0'")
 (doc
  (replace
    (@ (http://www.w3.org/1999/xlink:type "extended") (id "replace"))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "target")
      (http://www.w3.org/1999/xlink:role "booboo")
      (http://www.w3.org/1999/xlink:label "boo")
      (http://www.w3.org/1999/xlink:href "#replace")))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "ending resource1")
      (http://www.w3.org/1999/xlink:role "text/xml")
      (http://www.w3.org/1999/xlink:label "hoge")
      (http://www.w3.org/1999/xlink:href "target.xml")))
    (arc
     (@
      (http://www.w3.org/1999/xlink:type "arc")
      (http://www.w3.org/1999/xlink:to "hoge")
      (http://www.w3.org/1999/xlink:title "replace traversal example")
      (http://www.w3.org/1999/xlink:show "replace")
      (http://www.w3.org/1999/xlink:from "boo")
      (http://www.w3.org/1999/xlink:actuate "onRequest"))))
  (new
   (@ (http://www.w3.org/1999/xlink:type "extended") (id "new"))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "target")
     (http://www.w3.org/1999/xlink:role "booboo")
     (http://www.w3.org/1999/xlink:label "boo")
     (http://www.w3.org/1999/xlink:href "#new")))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "ending resource2")
     (http://www.w3.org/1999/xlink:role "text/xml")
     (http://www.w3.org/1999/xlink:label "hoge")
     (http://www.w3.org/1999/xlink:href "target.xml")))
   (arc
    (@
     (http://www.w3.org/1999/xlink:type "arc")
     (http://www.w3.org/1999/xlink:to "hoge")
     (http://www.w3.org/1999/xlink:title "new traversal example")
     (http://www.w3.org/1999/xlink:show "new")
     (http://www.w3.org/1999/xlink:from "boo")
     (http://www.w3.org/1999/xlink:actuate "onRequest"))))
  (embed
   (@ (http://www.w3.org/1999/xlink:type "extended") (id "embed"))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "target")
     (http://www.w3.org/1999/xlink:role "booboo")
     (http://www.w3.org/1999/xlink:label "boo")
     (http://www.w3.org/1999/xlink:href "#embed")))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "ending resource3")
     (http://www.w3.org/1999/xlink:role "text/xml")
     (http://www.w3.org/1999/xlink:label "hoge")
     (http://www.w3.org/1999/xlink:href "target.xml")))
   (arc
    (@
     (http://www.w3.org/1999/xlink:type "arc")
     (http://www.w3.org/1999/xlink:to "hoge")
     (http://www.w3.org/1999/xlink:title "embed traversal example")
     (http://www.w3.org/1999/xlink:show "embed")
     (http://www.w3.org/1999/xlink:from "boo")
     (http://www.w3.org/1999/xlink:actuate "onRequest"))))))
; <--- of:
(SSAX:multi-parser (quote id))
(open-input-resource "test1.xml")
)

; (SSAX:multi-parser (quote id))
(xtest-assert ; Expected result:
'(*TOP*
 (@@
  (id-index
    ("here"
     appendix
     (@ (id "here"))
     (bibliographic
       (item
        (author "Who1")
        (title "XML Linking Language (XLink)")
        (ref "foo.com"))
       (item
        (author "Who2")
        (title "XML Pointing Language (XPointer)")
        (ref "boo.com"))))
    ("chap7" chapter (@ (id "chap7")) (title "Conclusion") (p "Thanks a lot."))
    ("chap6" chapter (@ (id "chap6")) (title "samples"))
    ("chap5"
     chapter
     (@ (id "chap5"))
     (title "Models for using XLink/XPointer ")
     (p "There are important keywords."))
    ("chap4"
     chapter
     (@ (id "chap4"))
     (title "What is XPointer?")
     (p
      "XPointer is the fragment identifier of documents having the mime-type hogehoge."))
    ("chap3" chapter (@ (id "chap3")) (title "What is XLink?") (p "hyperlink"))
    ("chap2"
     chapter
     (@ (id "chap2"))
     (title "Introduction")
     (section
       (@ (ID "sec2-1"))
       (p
        "This document is written in XML (eXtensible Markup Language) ver.1.0.")))
    ("sec2-1"
     section
     (@ (ID "sec2-1"))
     (p
      "This document is written in XML (eXtensible Markup Language) ver.1.0."))
    ("chap1"
     chapter
     (@ (id "chap1"))
     (title "Abstract")
     (p "This document describes about XLink Engine..."))
    ("toc7" item (@ (id "toc7")) "chapter7")
    ("toc6" item (@ (id "toc6")) "chapter6")
    ("toc5" item (@ (id "toc5")) "chapter5")
    ("toc4" item (@ (id "toc4")) "chapter4")
    ("toc3" item (@ (id "toc3")) "chapter3")
    ("toc2" item (@ (id "toc2")) "chapter2")
    ("toc1" item (@ (id "toc1")) "chapter1")))
 (*PI* xml "version='1.0' encoding=\"Shift_JIS\"")
 (doc
  (multidirectional
    (@ (http://www.w3.org/1999/xlink:type "extended"))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "Chap.1 toc")
      (http://www.w3.org/1999/xlink:role "booboo")
      (http://www.w3.org/1999/xlink:label "boo")
      (http://www.w3.org/1999/xlink:href "#toc1")))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "Chap.1 cont")
      (http://www.w3.org/1999/xlink:role "text/xml")
      (http://www.w3.org/1999/xlink:label "hoge")
      (http://www.w3.org/1999/xlink:href "#chap1")))
    (arc
     (@
      (http://www.w3.org/1999/xlink:type "arc")
      (http://www.w3.org/1999/xlink:to "hoge")
      (http://www.w3.org/1999/xlink:title "Traversal to content page")
      (http://www.w3.org/1999/xlink:show "replace")
      (http://www.w3.org/1999/xlink:from "boo")
      (http://www.w3.org/1999/xlink:actuate "onRequest")))
    (arc
     (@
      (http://www.w3.org/1999/xlink:type "arc")
      (http://www.w3.org/1999/xlink:to "boo")
      (http://www.w3.org/1999/xlink:title "Traversal to toc page")
      (http://www.w3.org/1999/xlink:show "replace")
      (http://www.w3.org/1999/xlink:from "hoge")
      (http://www.w3.org/1999/xlink:actuate "onRequest"))))
  (item (@ (id "toc1")) "chapter1")
  (item (@ (id "toc2")) "chapter2")
  (item (@ (id "toc3")) "chapter3")
  (item (@ (id "toc4")) "chapter4")
  (item (@ (id "toc5")) "chapter5")
  (item (@ (id "toc6")) "chapter6")
  (item (@ (id "toc7")) "chapter7")
  (body
   (chapter
     (@ (id "chap1"))
     (title "Abstract")
     (p "This document describes about XLink Engine..."))
   (chapter
     (@ (id "chap2"))
     (title "Introduction")
     (section
       (@ (ID "sec2-1"))
       (p
        "This document is written in XML (eXtensible Markup Language) ver.1.0.")))
   (chapter (@ (id "chap3")) (title "What is XLink?") (p "hyperlink"))
   (chapter
     (@ (id "chap4"))
     (title "What is XPointer?")
     (p
      "XPointer is the fragment identifier of documents having the mime-type hogehoge."))
   (chapter
     (@ (id "chap5"))
     (title "Models for using XLink/XPointer ")
     (p "There are important keywords."))
   (chapter (@ (id "chap6")) (title "samples"))
   (chapter (@ (id "chap7")) (title "Conclusion") (p "Thanks a lot."))
   (appendix
     (@ (id "here"))
     (bibliographic
       (item
        (author "Who1")
        (title "XML Linking Language (XLink)")
        (ref "foo.com"))
       (item
        (author "Who2")
        (title "XML Pointing Language (XPointer)")
        (ref "boo.com")))))))
; <--- of:
(SSAX:multi-parser (quote id))
(open-input-resource "test2.xml")
)


;------------------------------------------------
; Both id and xlink

; (SSAX:multi-parser (quote id) (quote xlink))
(xtest-assert ; Expected result:
'(*TOP*
 (@@
  (sxlink
    (traversal-info
      ("target.xml"
       #f
       #f
       "text/xml"
       580
       (loc
        (@
         (http://www.w3.org/1999/xlink:type "locator")
         (http://www.w3.org/1999/xlink:title "ending resource1")
         (http://www.w3.org/1999/xlink:role "text/xml")
         (http://www.w3.org/1999/xlink:label "hoge")
         (http://www.w3.org/1999/xlink:href "target.xml"))))
      (#f
       #f
       "replace"
       "booboo"
       454
       (loc
        (@
         (http://www.w3.org/1999/xlink:type "locator")
         (http://www.w3.org/1999/xlink:title "target")
         (http://www.w3.org/1999/xlink:role "booboo")
         (http://www.w3.org/1999/xlink:label "boo")
         (http://www.w3.org/1999/xlink:href "#replace")))
       ("target.xml"
        #f
        "text/xml"
        580
        (loc
         (@
          (http://www.w3.org/1999/xlink:type "locator")
          (http://www.w3.org/1999/xlink:title "ending resource1")
          (http://www.w3.org/1999/xlink:role "text/xml")
          (http://www.w3.org/1999/xlink:label "hoge")
          (http://www.w3.org/1999/xlink:href "target.xml")))
        #f
        "replace"
        "onRequest"))
      ("target.xml"
       #f
       #f
       "text/xml"
       1007
       (loc
        (@
         (http://www.w3.org/1999/xlink:type "locator")
         (http://www.w3.org/1999/xlink:title "ending resource2")
         (http://www.w3.org/1999/xlink:role "text/xml")
         (http://www.w3.org/1999/xlink:label "hoge")
         (http://www.w3.org/1999/xlink:href "target.xml"))))
      (#f
       #f
       "new"
       "booboo"
       881
       (loc
        (@
         (http://www.w3.org/1999/xlink:type "locator")
         (http://www.w3.org/1999/xlink:title "target")
         (http://www.w3.org/1999/xlink:role "booboo")
         (http://www.w3.org/1999/xlink:label "boo")
         (http://www.w3.org/1999/xlink:href "#new")))
       ("target.xml"
        #f
        "text/xml"
        1007
        (loc
         (@
          (http://www.w3.org/1999/xlink:type "locator")
          (http://www.w3.org/1999/xlink:title "ending resource2")
          (http://www.w3.org/1999/xlink:role "text/xml")
          (http://www.w3.org/1999/xlink:label "hoge")
          (http://www.w3.org/1999/xlink:href "target.xml")))
        #f
        "new"
        "onRequest"))
      ("target.xml"
       #f
       #f
       "text/xml"
       1428
       (loc
        (@
         (http://www.w3.org/1999/xlink:type "locator")
         (http://www.w3.org/1999/xlink:title "ending resource3")
         (http://www.w3.org/1999/xlink:role "text/xml")
         (http://www.w3.org/1999/xlink:label "hoge")
         (http://www.w3.org/1999/xlink:href "target.xml"))))
      (#f
       #f
       "embed"
       "booboo"
       1302
       (loc
        (@
         (http://www.w3.org/1999/xlink:type "locator")
         (http://www.w3.org/1999/xlink:title "target")
         (http://www.w3.org/1999/xlink:role "booboo")
         (http://www.w3.org/1999/xlink:label "boo")
         (http://www.w3.org/1999/xlink:href "#embed")))
       ("target.xml"
        #f
        "text/xml"
        1428
        (loc
         (@
          (http://www.w3.org/1999/xlink:type "locator")
          (http://www.w3.org/1999/xlink:title "ending resource3")
          (http://www.w3.org/1999/xlink:role "text/xml")
          (http://www.w3.org/1999/xlink:label "hoge")
          (http://www.w3.org/1999/xlink:href "target.xml")))
        #f
        "embed"
        "onRequest")))
    (roles
     ("booboo"
      454
      (loc
       (@
        (http://www.w3.org/1999/xlink:type "locator")
        (http://www.w3.org/1999/xlink:title "target")
        (http://www.w3.org/1999/xlink:role "booboo")
        (http://www.w3.org/1999/xlink:label "boo")
        (http://www.w3.org/1999/xlink:href "#replace"))))
     ("text/xml"
      580
      (loc
       (@
        (http://www.w3.org/1999/xlink:type "locator")
        (http://www.w3.org/1999/xlink:title "ending resource1")
        (http://www.w3.org/1999/xlink:role "text/xml")
        (http://www.w3.org/1999/xlink:label "hoge")
        (http://www.w3.org/1999/xlink:href "target.xml"))))
     ("booboo"
      881
      (loc
       (@
        (http://www.w3.org/1999/xlink:type "locator")
        (http://www.w3.org/1999/xlink:title "target")
        (http://www.w3.org/1999/xlink:role "booboo")
        (http://www.w3.org/1999/xlink:label "boo")
        (http://www.w3.org/1999/xlink:href "#new"))))
     ("text/xml"
      1007
      (loc
       (@
        (http://www.w3.org/1999/xlink:type "locator")
        (http://www.w3.org/1999/xlink:title "ending resource2")
        (http://www.w3.org/1999/xlink:role "text/xml")
        (http://www.w3.org/1999/xlink:label "hoge")
        (http://www.w3.org/1999/xlink:href "target.xml"))))
     ("booboo"
      1302
      (loc
       (@
        (http://www.w3.org/1999/xlink:type "locator")
        (http://www.w3.org/1999/xlink:title "target")
        (http://www.w3.org/1999/xlink:role "booboo")
        (http://www.w3.org/1999/xlink:label "boo")
        (http://www.w3.org/1999/xlink:href "#embed"))))
     ("text/xml"
      1428
      (loc
       (@
        (http://www.w3.org/1999/xlink:type "locator")
        (http://www.w3.org/1999/xlink:title "ending resource3")
        (http://www.w3.org/1999/xlink:role "text/xml")
        (http://www.w3.org/1999/xlink:label "hoge")
        (http://www.w3.org/1999/xlink:href "target.xml")))))
    (arcroles))
  (id-index
    ("embed"
     embed
     (@ (http://www.w3.org/1999/xlink:type "extended") (id "embed"))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "target")
       (http://www.w3.org/1999/xlink:role "booboo")
       (http://www.w3.org/1999/xlink:label "boo")
       (http://www.w3.org/1999/xlink:href "#embed")))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "ending resource3")
       (http://www.w3.org/1999/xlink:role "text/xml")
       (http://www.w3.org/1999/xlink:label "hoge")
       (http://www.w3.org/1999/xlink:href "target.xml")))
     (arc
      (@
       (http://www.w3.org/1999/xlink:type "arc")
       (http://www.w3.org/1999/xlink:to "hoge")
       (http://www.w3.org/1999/xlink:title "embed traversal example")
       (http://www.w3.org/1999/xlink:show "embed")
       (http://www.w3.org/1999/xlink:from "boo")
       (http://www.w3.org/1999/xlink:actuate "onRequest"))))
    ("new"
     new
     (@ (http://www.w3.org/1999/xlink:type "extended") (id "new"))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "target")
       (http://www.w3.org/1999/xlink:role "booboo")
       (http://www.w3.org/1999/xlink:label "boo")
       (http://www.w3.org/1999/xlink:href "#new")))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "ending resource2")
       (http://www.w3.org/1999/xlink:role "text/xml")
       (http://www.w3.org/1999/xlink:label "hoge")
       (http://www.w3.org/1999/xlink:href "target.xml")))
     (arc
      (@
       (http://www.w3.org/1999/xlink:type "arc")
       (http://www.w3.org/1999/xlink:to "hoge")
       (http://www.w3.org/1999/xlink:title "new traversal example")
       (http://www.w3.org/1999/xlink:show "new")
       (http://www.w3.org/1999/xlink:from "boo")
       (http://www.w3.org/1999/xlink:actuate "onRequest"))))
    ("replace"
     replace
     (@ (http://www.w3.org/1999/xlink:type "extended") (id "replace"))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "target")
       (http://www.w3.org/1999/xlink:role "booboo")
       (http://www.w3.org/1999/xlink:label "boo")
       (http://www.w3.org/1999/xlink:href "#replace")))
     (loc
      (@
       (http://www.w3.org/1999/xlink:type "locator")
       (http://www.w3.org/1999/xlink:title "ending resource1")
       (http://www.w3.org/1999/xlink:role "text/xml")
       (http://www.w3.org/1999/xlink:label "hoge")
       (http://www.w3.org/1999/xlink:href "target.xml")))
     (arc
      (@
       (http://www.w3.org/1999/xlink:type "arc")
       (http://www.w3.org/1999/xlink:to "hoge")
       (http://www.w3.org/1999/xlink:title "replace traversal example")
       (http://www.w3.org/1999/xlink:show "replace")
       (http://www.w3.org/1999/xlink:from "boo")
       (http://www.w3.org/1999/xlink:actuate "onRequest"))))))
 (*PI* xml "version='1.0'")
 (doc
  (replace
    (@ (http://www.w3.org/1999/xlink:type "extended") (id "replace"))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "target")
      (http://www.w3.org/1999/xlink:role "booboo")
      (http://www.w3.org/1999/xlink:label "boo")
      (http://www.w3.org/1999/xlink:href "#replace")))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "ending resource1")
      (http://www.w3.org/1999/xlink:role "text/xml")
      (http://www.w3.org/1999/xlink:label "hoge")
      (http://www.w3.org/1999/xlink:href "target.xml")))
    (arc
     (@
      (http://www.w3.org/1999/xlink:type "arc")
      (http://www.w3.org/1999/xlink:to "hoge")
      (http://www.w3.org/1999/xlink:title "replace traversal example")
      (http://www.w3.org/1999/xlink:show "replace")
      (http://www.w3.org/1999/xlink:from "boo")
      (http://www.w3.org/1999/xlink:actuate "onRequest"))))
  (new
   (@ (http://www.w3.org/1999/xlink:type "extended") (id "new"))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "target")
     (http://www.w3.org/1999/xlink:role "booboo")
     (http://www.w3.org/1999/xlink:label "boo")
     (http://www.w3.org/1999/xlink:href "#new")))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "ending resource2")
     (http://www.w3.org/1999/xlink:role "text/xml")
     (http://www.w3.org/1999/xlink:label "hoge")
     (http://www.w3.org/1999/xlink:href "target.xml")))
   (arc
    (@
     (http://www.w3.org/1999/xlink:type "arc")
     (http://www.w3.org/1999/xlink:to "hoge")
     (http://www.w3.org/1999/xlink:title "new traversal example")
     (http://www.w3.org/1999/xlink:show "new")
     (http://www.w3.org/1999/xlink:from "boo")
     (http://www.w3.org/1999/xlink:actuate "onRequest"))))
  (embed
   (@ (http://www.w3.org/1999/xlink:type "extended") (id "embed"))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "target")
     (http://www.w3.org/1999/xlink:role "booboo")
     (http://www.w3.org/1999/xlink:label "boo")
     (http://www.w3.org/1999/xlink:href "#embed")))
   (loc
    (@
     (http://www.w3.org/1999/xlink:type "locator")
     (http://www.w3.org/1999/xlink:title "ending resource3")
     (http://www.w3.org/1999/xlink:role "text/xml")
     (http://www.w3.org/1999/xlink:label "hoge")
     (http://www.w3.org/1999/xlink:href "target.xml")))
   (arc
    (@
     (http://www.w3.org/1999/xlink:type "arc")
     (http://www.w3.org/1999/xlink:to "hoge")
     (http://www.w3.org/1999/xlink:title "embed traversal example")
     (http://www.w3.org/1999/xlink:show "embed")
     (http://www.w3.org/1999/xlink:from "boo")
     (http://www.w3.org/1999/xlink:actuate "onRequest"))))))
; <--- of:
(SSAX:multi-parser (quote id) (quote xlink))
(open-input-resource "test1.xml")
)

; (SSAX:multi-parser (quote id) (quote xlink))
(xtest-assert ; Expected result:
'(*TOP*
 (@@
  (sxlink
    (traversal-info
      (#f
       #f
       "chap1"
       "text/xml"
       403
       (loc
        (@
         (http://www.w3.org/1999/xlink:type "locator")
         (http://www.w3.org/1999/xlink:title "Chap.1 cont")
         (http://www.w3.org/1999/xlink:role "text/xml")
         (http://www.w3.org/1999/xlink:label "hoge")
         (http://www.w3.org/1999/xlink:href "#chap1")))
       (#f
        "toc1"
        "booboo"
        286
        (loc
         (@
          (http://www.w3.org/1999/xlink:type "locator")
          (http://www.w3.org/1999/xlink:title "Chap.1 toc")
          (http://www.w3.org/1999/xlink:role "booboo")
          (http://www.w3.org/1999/xlink:label "boo")
          (http://www.w3.org/1999/xlink:href "#toc1")))
        #f
        "replace"
        "onRequest"))
      (#f
       #f
       "toc1"
       "booboo"
       286
       (loc
        (@
         (http://www.w3.org/1999/xlink:type "locator")
         (http://www.w3.org/1999/xlink:title "Chap.1 toc")
         (http://www.w3.org/1999/xlink:role "booboo")
         (http://www.w3.org/1999/xlink:label "boo")
         (http://www.w3.org/1999/xlink:href "#toc1")))
       (#f
        "chap1"
        "text/xml"
        403
        (loc
         (@
          (http://www.w3.org/1999/xlink:type "locator")
          (http://www.w3.org/1999/xlink:title "Chap.1 cont")
          (http://www.w3.org/1999/xlink:role "text/xml")
          (http://www.w3.org/1999/xlink:label "hoge")
          (http://www.w3.org/1999/xlink:href "#chap1")))
        #f
        "replace"
        "onRequest")))
    (roles
     ("booboo"
      286
      (loc
       (@
        (http://www.w3.org/1999/xlink:type "locator")
        (http://www.w3.org/1999/xlink:title "Chap.1 toc")
        (http://www.w3.org/1999/xlink:role "booboo")
        (http://www.w3.org/1999/xlink:label "boo")
        (http://www.w3.org/1999/xlink:href "#toc1"))))
     ("text/xml"
      403
      (loc
       (@
        (http://www.w3.org/1999/xlink:type "locator")
        (http://www.w3.org/1999/xlink:title "Chap.1 cont")
        (http://www.w3.org/1999/xlink:role "text/xml")
        (http://www.w3.org/1999/xlink:label "hoge")
        (http://www.w3.org/1999/xlink:href "#chap1")))))
    (arcroles))
  (id-index
    ("here"
     appendix
     (@ (id "here"))
     (bibliographic
       (item
        (author "Who1")
        (title "XML Linking Language (XLink)")
        (ref "foo.com"))
       (item
        (author "Who2")
        (title "XML Pointing Language (XPointer)")
        (ref "boo.com"))))
    ("chap7" chapter (@ (id "chap7")) (title "Conclusion") (p "Thanks a lot."))
    ("chap6" chapter (@ (id "chap6")) (title "samples"))
    ("chap5"
     chapter
     (@ (id "chap5"))
     (title "Models for using XLink/XPointer ")
     (p "There are important keywords."))
    ("chap4"
     chapter
     (@ (id "chap4"))
     (title "What is XPointer?")
     (p
      "XPointer is the fragment identifier of documents having the mime-type hogehoge."))
    ("chap3" chapter (@ (id "chap3")) (title "What is XLink?") (p "hyperlink"))
    ("chap2"
     chapter
     (@ (id "chap2"))
     (title "Introduction")
     (section
       (@ (ID "sec2-1"))
       (p
        "This document is written in XML (eXtensible Markup Language) ver.1.0.")))
    ("sec2-1"
     section
     (@ (ID "sec2-1"))
     (p
      "This document is written in XML (eXtensible Markup Language) ver.1.0."))
    ("chap1"
     chapter
     (@ (id "chap1"))
     (title "Abstract")
     (p "This document describes about XLink Engine..."))
    ("toc7" item (@ (id "toc7")) "chapter7")
    ("toc6" item (@ (id "toc6")) "chapter6")
    ("toc5" item (@ (id "toc5")) "chapter5")
    ("toc4" item (@ (id "toc4")) "chapter4")
    ("toc3" item (@ (id "toc3")) "chapter3")
    ("toc2" item (@ (id "toc2")) "chapter2")
    ("toc1" item (@ (id "toc1")) "chapter1")))
 (*PI* xml "version='1.0' encoding=\"Shift_JIS\"")
 (doc
  (multidirectional
    (@ (http://www.w3.org/1999/xlink:type "extended"))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "Chap.1 toc")
      (http://www.w3.org/1999/xlink:role "booboo")
      (http://www.w3.org/1999/xlink:label "boo")
      (http://www.w3.org/1999/xlink:href "#toc1")))
    (loc
     (@
      (http://www.w3.org/1999/xlink:type "locator")
      (http://www.w3.org/1999/xlink:title "Chap.1 cont")
      (http://www.w3.org/1999/xlink:role "text/xml")
      (http://www.w3.org/1999/xlink:label "hoge")
      (http://www.w3.org/1999/xlink:href "#chap1")))
    (arc
     (@
      (http://www.w3.org/1999/xlink:type "arc")
      (http://www.w3.org/1999/xlink:to "hoge")
      (http://www.w3.org/1999/xlink:title "Traversal to content page")
      (http://www.w3.org/1999/xlink:show "replace")
      (http://www.w3.org/1999/xlink:from "boo")
      (http://www.w3.org/1999/xlink:actuate "onRequest")))
    (arc
     (@
      (http://www.w3.org/1999/xlink:type "arc")
      (http://www.w3.org/1999/xlink:to "boo")
      (http://www.w3.org/1999/xlink:title "Traversal to toc page")
      (http://www.w3.org/1999/xlink:show "replace")
      (http://www.w3.org/1999/xlink:from "hoge")
      (http://www.w3.org/1999/xlink:actuate "onRequest"))))
  (item (@ (id "toc1")) "chapter1")
  (item (@ (id "toc2")) "chapter2")
  (item (@ (id "toc3")) "chapter3")
  (item (@ (id "toc4")) "chapter4")
  (item (@ (id "toc5")) "chapter5")
  (item (@ (id "toc6")) "chapter6")
  (item (@ (id "toc7")) "chapter7")
  (body
   (chapter
     (@ (id "chap1"))
     (title "Abstract")
     (p "This document describes about XLink Engine..."))
   (chapter
     (@ (id "chap2"))
     (title "Introduction")
     (section
       (@ (ID "sec2-1"))
       (p
        "This document is written in XML (eXtensible Markup Language) ver.1.0.")))
   (chapter (@ (id "chap3")) (title "What is XLink?") (p "hyperlink"))
   (chapter
     (@ (id "chap4"))
     (title "What is XPointer?")
     (p
      "XPointer is the fragment identifier of documents having the mime-type hogehoge."))
   (chapter
     (@ (id "chap5"))
     (title "Models for using XLink/XPointer ")
     (p "There are important keywords."))
   (chapter (@ (id "chap6")) (title "samples"))
   (chapter (@ (id "chap7")) (title "Conclusion") (p "Thanks a lot."))
   (appendix
     (@ (id "here"))
     (bibliographic
       (item
        (author "Who1")
        (title "XML Linking Language (XLink)")
        (ref "foo.com"))
       (item
        (author "Who2")
        (title "XML Pointing Language (XPointer)")
        (ref "boo.com")))))))
; <--- of:
(SSAX:multi-parser (quote id) (quote xlink))
(open-input-resource "test2.xml")
)
